"use strict";

module.exports = {
    /**
     * Resolves alias references in a middleware cahin
     * @param middleware
     */
    process: function process(middleware, conf) {
        var isAlias = function (x) {
            return typeof x === "string";
        };
        var getAlias = function (aliasName) {
            var found = conf.aliases[aliasName];
            if (!found) {
                throw new Error("could not find alias " + aliasName);
            }
            return found;
        };

        for (var i = middleware.length - 1; i >= 0; i--) {
            if (isAlias(middleware[i])) {
                var aliasResult = getAlias(middleware[i]);
                middleware.splice.apply(middleware, [i, 1].concat(aliasResult));
            }
        }
        return middleware;
    }
};