"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var key in props) { var prop = props[key]; prop.configurable = true; if (prop.value) prop.writable = true; } Object.defineProperties(target, props); } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var chainProcessor = require("./chain_processor"),
    middlewareComposer = require("./middleware_composer");
var debug = require("debug")("jefferson");

/**
 * Configures routes within the express app.
 */

var Routes = (function () {
    function Routes(app, conf) {
        _classCallCheck(this, Routes);

        this.app = app;
        this.conf = conf;
    }

    _createClass(Routes, {
        configure: {
            value: function configure() {
                var _this = this;

                var routeNames = Object.keys(this.conf.routes);
                debug("detected " + routeNames.length + " routes");
                routeNames.forEach(function (routeName) {
                    var route = _this.conf.routes[routeName];
                    _this.wireRoute(routeName, route);
                });
            }
        },
        wireRoute: {

            /**
             * Configures a single route in the express app/router.
             * @param routeName The name of the route
             * @param route The route configuration
             */

            value: function wireRoute(routeName, route) {
                var method = route.method.toLowerCase();
                var path = route.path;
                var middleware = middlewareComposer.compose(route, this.conf);
                middleware = chainProcessor.process(middleware, this.conf);
                debug("\"" + routeName + "\": " + method.toUpperCase() + " " + path + " - " + middleware.length + " middlewares");
                this.app[method](path, middleware);
            }
        }
    });

    return Routes;
})();

module.exports = Routes;