"use strict";

/**
 * Safe HTTP Methods
 */
var safeMethods = {
    get: true,
    head: true,
    options: true
};

/**
 * Composes a middleware chain by taking a core chain and adding boilerplate pre and post sections
 * to it
 */
module.exports = {
    compose: function compose(route, conf) {
        var result = [];
        var method = route.method.toLowerCase();
        var isSafe = function () {
            return safeMethods[method];
        };
        var add = function () {
            var x = arguments[0] === undefined ? [] : arguments[0];
            return result = result.concat(x);
        };

        add(conf.pre.all);
        add(isSafe() ? conf.pre.safe : conf.pre.unsafe);
        add(conf.pre.method[method]);
        add(route.middleware);
        add(conf.post.method[method]);
        add(isSafe() ? conf.post.safe : conf.post.unsafe);
        add(conf.post.all);
        return result;
    }
};