"use strict";

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var boilerplateSection = function (section) {
    var result = section || {};
    var initSubsection = function (name) {
        var defaultValue = arguments[1] === undefined ? [] : arguments[1];

        if (!result[name]) {
            result[name] = defaultValue;
        }
    };
    initSubsection("all");
    initSubsection("safe");
    initSubsection("unsafe");
    initSubsection("method", {});
    return result;
};

/**
 * The configuration class provides sane defaults for incoming configuration values.
 */

var Configuration = function Configuration(conf) {
    _classCallCheck(this, Configuration);

    this.routes = conf.routes || {};
    this.params = conf.params || {};
    this.aliases = conf.aliases || {};
    this.proxies = conf.proxies || [];
    this.locals = conf.locals || {};
    this.enable = conf.enable || [];
    this.disable = conf.disable || [];
    this.engines = conf.engines || [];
    this.settings = conf.settings || {};
    this.pre = boilerplateSection(conf.pre);
    this.post = boilerplateSection(conf.post);
};

module.exports = Configuration;